# Upcoming
## v1.0
* Switched build to CMake
* Completely overhauled code structure
    * Separate code into logical blocks
    * Purge global variables as much as possible
* Add a desktop entry when installing
  based on [desktopentry](https://st.suckless.org/patches/desktopentry/)

## v1.1
* Configurable transparency (focused and unfocused)
  based on [alpha](https://st.suckless.org/patches/alpha/) and 
  [alpha focus highlight](https://st.suckless.org/patches/alpha_focus_highlight/)
* Proper resizing (aka don't snap to nearest character size)
  based on [anysize](https://st.suckless.org/patches/anysize/)
* Copy to clipboard on selection
  based on [one clipboard](https://st.suckless.org/patches/clipboard/)

## v1.2
* Add better/gapless rendering of lines/blocks
  based on [boxdraw](https://st.suckless.org/patches/boxdraw/)
* Add support for multiple fonts
  based on [font2](https://st.suckless.org/patches/font2/)
* Hide cursor when working in the terminal
  based on [hidecursor](https://st.suckless.org/patches/hidecursor/)

## v2.0
* Add ligature support
  based on [ligature support](https://st.suckless.org/patches/ligatures/)
* Support for multiple color pallets
* Paste on right click
* Scrollback support
* Center lines smaller than max height
  based on [vertcenter](https://st.suckless.org/patches/vertcenter/)
* Visual bell
  based on [visualbell](https://st.suckless.org/patches/visualbell/)
